//+------------------------------------------------------------------+
//|																geSCtrl_Tick_v2.mq4	|
//|																forte928				|
//|                                        									|
//+------------------------------------------------------------------+
#property copyright "forte928"
#property link      ""
/*
	        -  
	      	  , 
	          
	      ..
	
          ..
              (  )..
           (  -  )
    (CE_Time  CE_Count )

         (  -     )
    (  -           -1).
         _Emulated
_Emulated=0 -  
_Emulated=1  ..
         "F3"
      "Auto Emulate"   "Manual Emulate" -        ..

             ..
   _PauseCount       
   _CW_xxxxx -       ..
      _CW_xxxxx=true.. 
   _CW_xxxxx -        
           ..
            CE_Time


             , 
   
            
	
	         Mover.mq4..
*/
	//#include <WinUser32.mqh> .      4.
	//PostMessageA (WindowHandle (Symbol(), 0), WM_COMMAND, 33324, 0); //    
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
//==============================================================
//Control Emulated --> "CE_"
#include <WinUser32.mqh> //    "user32.dll"  API Windows XP.
#include <ge_VKKeyCode.mq4>
//#include "ge_Debug.mq4"

#define WM_COMMAND   0x0111

#define gnObject		"CE_Ctrl"
#define gnLabel		"CE_Label"
#define gnCount		"CE_Count"
#define gnTime			"CE_Time"
#define gnEmulate		"_Emulated"
#define gnCalculate	"_CW_"			// Calculate Switch -        
#define gnPauseCount	"_PauseCount"


#property show_inputs

//==============================================================
string	iSymbol;
int		iPeriod;
bool		IsWorking=true;					//     
int		TimeRight,TimeLeft;				//	   ()
int		TickPrd,TickLeft,TickRight;	//    ()
int		TimeRSave,TimeLSave;				//    ()

int		SetBars		=0;					//     
datetime	SetTime		=0;					//	    
bool		Emulated		=false;				//    ,    F3
													// false -  (  )
													//	true	-      "0"  
bool		Calculated	=false;				//     (,   )
extern int PauseCount	=100;				//      100.
int		PauseWait	=0;					//       
bool		Modifed		=false;				//     
string	CWName		="";
int		CWCount		=0;
/*

     :
 "// -->"           

#define		IndicatorName "LR_MA"	//     

...

extern int	Shift=0;			//      	// -->
extern int	Count=1000;		//  -   

...
#include "ge_TicketCtrl.mq4"													// -->
//  ge_TicketCtrl.mq4 -    extern	bool	cwEmulated=false;
//         -     cwEmulated=false,
//     -    cwEmulated=true
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Custom indicator initialization function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int init()
{

		.....

	InitTicket(IndicatorName);		//          // -->
											// _CW_xxxxx,        
											//      ..
//----
	return(0);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int deinit()
  {
//----
		...
	DoneTicket();																	// -->
//----
   return(0);
  }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~V~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int start()
{
	if (StartTicket(Shift)==false)											// -->
	{																					// -->
    int limit;
     int counted_bars=IndicatorCounted();
  //----     
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
	}																					// -->
	else {																			// -->
		if (Calculated==true) return(0);										// -->
	}																					// -->

  //----  
	ReadValueTicket(Shift,Ix);													// -->

	double Rates[],TimeBuf1[];
	ArrayResize(Rates);ArrayResize(TimeBuf1);
	for (Ix=0;Ix<Count;Ix++) Rates[Ix]=Close[Ix+Shift];

	LineRegressOnArray(Rates,TimeBuf1,DeGree,LRCalc);			//      TimeBuf1
	// SetIndexBuffer(0, FxView1);
	ArrayCopy(FxView1,TimeBuf1,Shift,0,Count);					//    
	

	CalculateFinishedTicket();													// -->
//----
   return(0);
  }
//+-----------------------------------------------------------------------------------------------+\\
//**************************************************************/
string EmulateState(bool iEmulate)
{
	if (iEmulate==true) return("Auto Emulate");
	else return("Manual Emulate");
}
int init() 
{
	//     ..
	PauseWait=500;
	if (GlobalVariableCheck(gnEmulate)==true)
	{
		GlobalVariableDel(gnEmulate);
		Sleep(PauseWait);
		if (GlobalVariableCheck(gnEmulate)==true) 
		{
			MessageBox("     ","",IDOK);
			return;
		}
	}
	PauseWait=0;
	
	iSymbol=Symbol();
	iPeriod=Period();
	
	TickPrd=100;
	TimeRight=WindowTimeOnDropped();//Print(TimeToStr(TimeRight,TIME_DATE|TIME_MINUTES));
	TickRight=iBarShift(NULL,iPeriod,TimeRight);
	TickLeft=WindowFirstVisibleBar();
	if ((TickLeft-TickRight)>TickPrd) TickLeft=TickRight+TickPrd;
	if ((TickLeft-TickRight)<TickPrd) TickRight=TickLeft-TickPrd;
	if (TickRight<0) {TickRight=0;TickLeft=TickPrd-1;}
   TimeLeft=Time[TickLeft];
	TimeRight=Time[TickRight];
	TimeRSave=TimeRight;
	TimeLSave=TimeLeft;
	
	ObjectCreate(gnObject,4,0,TimeLeft,0,TimeRight,0);
	ObjectSet(gnObject,OBJPROP_COLOR,Gold);
	ObjectCreate(gnLabel, OBJ_LABEL, 0, 0, 0);
	ObjectSetText(gnLabel,EmulateState(Emulated), 20, "Verdana", Yellow);
	ObjectSet(gnLabel, OBJPROP_XDISTANCE, 10);
	ObjectSet(gnLabel, OBJPROP_YDISTANCE, 50);
	
	GlobalVariableSet(gnCount,TickPrd);
	GlobalVariableSet(gnTime,TimeRight);
	GlobalVariableSet(gnEmulate,Emulated);
	//GlobalVariableSet(gnCalculate,Calculated);
	GlobalVariableSet(gnPauseCount,PauseCount);
	GlobalVariablesDeleteAll(gnCalculate);

	//PostMessageA (WindowHandle(iSymbol,iPeriod), WM_COMMAND, 33324, 0); //  .
	WindowRedraw();
}
//**************************************************************
int start() 
{
	if (PauseWait>0) return;
	PauseWait=0;
	int HandlWindow=WindowHandle(iSymbol,iPeriod);        
	//---- 
	while (IsWorking==true)
	{
		while(ObjectFind(gnObject)>=0)
		{
			//     		
			if (GlobalVariableCheck(gnEmulate)==false) GlobalVariableSet(gnEmulate,Emulated);
			Emulated=GlobalVariableGet(gnEmulate);
			if (GlobalVariableCheck(gnPauseCount)==false) GlobalVariableSet(gnPauseCount,PauseCount);
			PauseCount=GlobalVariableGet(gnPauseCount);
			if (PauseCount<100) {PauseCount=100;GlobalVariableSet(gnPauseCount,PauseCount);}
			
			Calculated=true;
			for (CWCount=0;CWCount<GlobalVariablesTotal();CWCount++)
			{
				CWName=GlobalVariableName(CWCount);
				if (StringFind(CWName,gnCalculate, 0)==0) Calculated=Calculated*GlobalVariableGet(CWName);
			}
			//if (GlobalVariableCheck(gnCalculate)==false) GlobalVariableSet(gnCalculate,false);
			//Calculated=GlobalVariableGet(gnCalculate);

			if (ObjectFind(gnLabel)<0)
			{
				Emulated=!Emulated;GlobalVariableSet(gnEmulate,Emulated);
				ObjectCreate(gnLabel, OBJ_LABEL, 0, 0, 0);
				ObjectSetText(gnLabel,EmulateState(Emulated), 20, "Verdana", Yellow);
				ObjectSet(gnLabel, OBJPROP_XDISTANCE, 10);
				ObjectSet(gnLabel, OBJPROP_YDISTANCE, 50);
			}
     		else ObjectSetText(gnLabel,EmulateState(Emulated), 20, "Verdana", Yellow);
     		
			if (Emulated==true)
			{
				//   	
				TimeRight=TimeRSave;
				TimeLeft=TimeLSave;
				PauseWait=PauseWait-100;
				if (PauseWait<=0) 
				{
					PauseWait=PauseCount;
					if (Calculated==true)
					{
						TickRight=iBarShift(NULL,iPeriod,TimeRight)-1;
						TickLeft=iBarShift(NULL,iPeriod,TimeLeft)-1;
						if (TickRight>=0)
						{
							TimeRight=Time[TickRight];
							TimeLeft=Time[TickLeft];
							ObjectSet(gnObject,OBJPROP_TIME2,TimeRight); 
							ObjectSet(gnObject,OBJPROP_TIME1,TimeLeft);
						}
						else GlobalVariableSet(gnEmulate,false); //    
					}
				}
				else{
					if (TimeRight!=ObjectGet(gnObject,OBJPROP_TIME2)) ObjectSet(gnObject,OBJPROP_TIME2,TimeRight); 
					if (TimeLeft!=ObjectGet(gnObject,OBJPROP_TIME1)) ObjectSet(gnObject,OBJPROP_TIME1,TimeLeft); 
					TickRight=iBarShift(NULL,iPeriod,TimeRight);
					TickLeft=iBarShift(NULL,iPeriod,TimeLeft);
				}
			}
			else {
				TimeRight=ObjectGet(gnObject,OBJPROP_TIME2); 
				TimeLeft=ObjectGet(gnObject,OBJPROP_TIME1); 
				if (TimeRight>Time[0]) TimeRight=Time[0]; 
				TickRight=iBarShift(NULL,iPeriod,TimeRight);
				TickLeft=iBarShift(NULL,iPeriod,TimeLeft);
			}
//      
			TickPrd=TickLeft-TickRight;
			if (TickPrd<10) 
			{
				TickPrd=10; 
				TickLeft=TickRight+TickPrd; 
				TimeLeft=Time[TickLeft];
				ObjectSet(gnObject,OBJPROP_TIME1,TimeLeft);
			}
			if (TimeRSave!=TimeRight || TimeLSave!=TimeLeft) 
			{
				GlobalVariableSet(gnCount,TickPrd);
				TimeRSave=TimeRight;
				TimeLSave=TimeLeft;
				Modifed=true;					//    
				//Debug("Modifed");
				if (WindowFirstVisibleBar()<TickLeft)
				{
					PostMessageA(HandlWindow, WM_KEYDOWN, VK_LEFT, 1);Sleep(50);
					PostMessageA(HandlWindow, WM_KEYDOWN, VK_LEFT, 1);Sleep(50);
					PostMessageA(HandlWindow, WM_KEYDOWN, VK_LEFT, 1);Sleep(50);PostMessageA(HandlWindow, WM_KEYUP, VK_LEFT, 1);
				}
				if ((WindowFirstVisibleBar()-WindowBarsPerChart())>TickRight)
				{
					PostMessageA(HandlWindow, WM_KEYDOWN, VK_RIGHT, 1);Sleep(50);
					PostMessageA(HandlWindow, WM_KEYDOWN, VK_RIGHT, 1);Sleep(50);
					PostMessageA(HandlWindow, WM_KEYDOWN, VK_RIGHT, 1);Sleep(50);PostMessageA(HandlWindow, WM_KEYUP, VK_RIGHT, 1);
				}
			} 
			if ((Calculated==true)&&(Modifed==true))
			{
				//GlobalVariableSet(gnCalculate,False);Print("Modifed ");
				for (CWCount=0;CWCount<GlobalVariablesTotal();CWCount++)
				{
					CWName=GlobalVariableName(CWCount);
					if (StringFind(CWName,gnCalculate, 0)==0) GlobalVariableSet(CWName,false);
				}
				GlobalVariableSet(gnTime,TimeRSave);
				//Print(TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)," : Script Tick ",TimeToStr(TimeRSave,TIME_DATE|TIME_SECONDS));
				Modifed=false;
				PostMessageA (HandlWindow, WM_COMMAND, 33324, 0); //  .
				PostMessageA (HandlWindow, WM_COMMAND, 2, 1); //    .
				//Debug("PostMessageA");
			}
			WindowRedraw();//PostMessageA (HandlWindow, WM_COMMAND, 33324, 0); //  .
			//PostMessageA (HandlWindow, WM_COMMAND, 2, 1); //    .
			Comment("TimeLeft :",TimeToStr(TimeLSave,TIME_DATE|TIME_MINUTES),"  LeftBar : ",TickLeft,"  RightBar : ",TickRight,"\n",
						WindowFirstVisibleBar(),"  ",WindowBarsPerChart());
			Sleep(100);
		}//====================     =====================================
		int Result=MessageBox("   ?", "Question", MB_YESNO|MB_ICONQUESTION);
		if(Result!=IDYES) 
		{
			ObjectCreate(gnObject,4,0,TimeLeft,0,TimeRight,0);
			ObjectSet(gnObject,OBJPROP_COLOR,Gold);
			WindowRedraw();//PostMessageA (WindowHandle(iSymbol,iPeriod), WM_COMMAND, 33324, 0); //  .
		} else IsWorking=False;
	}
//=============================================
	
	PauseWait=0;
	return(0);
}
//**************************************************************
void deinit() 
{
	if (PauseWait>0) return;
	ObjectDelete(gnObject); 
	ObjectDelete(gnLabel); 
	GlobalVariableDel(gnCount);
	GlobalVariableDel(gnEmulate);
	GlobalVariableDel(gnPauseCount);
	WindowRedraw();//PostMessageA (WindowHandle(iSymbol,iPeriod), WM_COMMAND, 33324, 0); //  .
	Sleep(500);
	GlobalVariablesDeleteAll(gnCalculate);
	//GlobalVariableDel(gnCalculate);
}
//**************************************************************

